<?php

namespace ShopWP\API\Tools;

use ShopWP\Messages;
use ShopWP\Utils;
use ShopWP\Options;

if (!defined('ABSPATH')) {
    exit();
}

class Cache extends \ShopWP\API
{
    public function __construct($DB_Settings_Syncing)
    {
        $this->DB_Settings_Syncing = $DB_Settings_Syncing;
    }

    public function delete_cache($request)
    {

        $result = $this->DB_Settings_Syncing->expire_sync();

        if (empty($result['delete_cache'])) {
            
            $wp_err = $this->DB_Settings_Syncing->api_error('Unable to clear ShopWP cache. Please reload and try again.', __METHOD__, __LINE__);

            return wp_send_json_error($wp_err);
        }
        
        return $result;
    }

    public function register_routes()
    {
        $this->api_route('/cache', 'POST', [$this, 'delete_cache']);
    }

    public function init()
    {
        add_action('rest_api_init', [$this, 'register_routes']);
    }

}
