<?php

namespace ShopWP\Render\Storefront;

defined('ABSPATH') ?: exit();

use ShopWP\Utils\Data;

class Defaults
{
    public $Render_Attributes;
    public $Products_Defaults;

    public function __construct($Render_Attributes, $Products_Defaults)
    {
        $this->Render_Attributes = $Render_Attributes;
        $this->Products_Defaults = $Products_Defaults;
    }

    public function create_product_query($user_atts) {
        return $this->Products_Defaults->create_product_query($user_atts);
    }

    public function storefront($attrs) {
        return array_replace([], $attrs);
    }

    public function all_attrs($attrs = [], $defaults = [])
    {
        // TODO: Remove hook in 6.0
        $settings = apply_filters('shopwp_storefront_default_payload_settings', array_merge(
            $this->Products_Defaults->all_attrs($attrs, $defaults),
            [
                'query' => $this->Render_Attributes->attr($attrs, 'query', '*'),
                'sort_by' => $this->Render_Attributes->attr(
                    $attrs,
                    'sort_by',
                    'TITLE'
                ),
                'reverse' => $this->Render_Attributes->attr(
                    $attrs,
                    'reverse',
                    false
                ),
                'page_size' => $this->Render_Attributes->attr(
                    $attrs,
                    'page_size',
                    10
                ),
                'show_tags' => $this->Render_Attributes->attr(
                    $attrs,
                    'show_tags',
                    true
                ),
                'show_vendors' => $this->Render_Attributes->attr(
                    $attrs,
                    'show_vendors',
                    true
                ),
                'show_types' => $this->Render_Attributes->attr(
                    $attrs,
                    'show_types',
                    true
                ),
                'show_collections' => $this->Render_Attributes->attr(
                    $attrs,
                    'show_collections',
                    true
                ),
                'show_price' => $this->Render_Attributes->attr(
                    $attrs,
                    'show_price',
                    true
                ),
                'show_selections' => $this->Render_Attributes->attr(
                    $attrs,
                    'show_selections',
                    true
                ),
                'show_sorting' => $this->Render_Attributes->attr(
                    $attrs,
                    'show_sorting',
                    true
                ),
                'show_pagination' => $this->Render_Attributes->attr(
                    $attrs,
                    'show_pagination',
                    true
                ),
                'show_options_heading' => $this->Render_Attributes->attr(
                    $attrs,
                    'show_options_heading',
                    true
                ),
                'dropzone_payload' => $this->Render_Attributes->attr(
                    $attrs,
                    'dropzone_payload',
                    '#shopwp-storefront-payload'
                ),
                'dropzone_options' => $this->Render_Attributes->attr(
                    $attrs,
                    'dropzone_options',
                    '#shopwp-storefront-options'
                ),
                'dropzone_selections' => $this->Render_Attributes->attr(
                    $attrs,
                    'dropzone_selections',
                    '#shopwp-storefront-selections'
                ),
                'dropzone_sorting' => $this->Render_Attributes->attr(
                    $attrs,
                    'dropzone_sorting',
                    '#shopwp-storefront-sort'
                ),
                'dropzone_page_size' => $this->Render_Attributes->attr(
                    $attrs,
                    'dropzone_page_size',
                    '#shopwp-storefront-page-size'
                ),            
                'dropzone_heading' => $this->Render_Attributes->attr(
                    $attrs,
                    'dropzone_heading',
                    false
                ),
                'dropzone_load_more' => $this->Render_Attributes->attr(
                    $attrs,
                    'dropzone_load_more',
                    true
                ),
                'dropzone_loader' => $this->Render_Attributes->attr(
                    $attrs,
                    'dropzone_loader',
                    false
                ),
                'dropzone_notices' => $this->Render_Attributes->attr(
                    $attrs,
                    'dropzone_notices',
                    false
                ),
                'pagination' => $this->Render_Attributes->attr(
                    $attrs,
                    'pagination',
                    true
                ),
                'no_results_text' => $this->Render_Attributes->attr(
                    $attrs,
                    'no_results_text',
                    $defaults['n']['noResultsFound']
                ),
                'excludes' => $this->Render_Attributes->attr($attrs, 'excludes', [
                    'description',
                ]),
                'items_per_row' => $this->Render_Attributes->attr(
                    $attrs,
                    'items_per_row',
                    3
                ),
                'limit' => $this->Render_Attributes->attr($attrs, 'limit', false),
                'skip_initial_render' => $this->Render_Attributes->attr(
                    $attrs,
                    'skip_initial_render',
                    false
                ),
                'infinite_scroll' => $this->Render_Attributes->attr(
                    $attrs,
                    'infinite_scroll',
                    false
                ),
                'infinite_scroll_offset' => $this->Render_Attributes->attr(
                    $attrs,
                    'infinite_scroll_offset',
                    -200
                ),
                'query_type' => $this->Render_Attributes->attr(
                    $attrs,
                    'query_type',
                    'products'
                ),
                'price' => $this->Render_Attributes->attr(
                    $attrs,
                    'price',
                    false
                ),
                'connective' => $this->Render_Attributes->attr(
                    $attrs,
                    'connective',
                    SHOPWP_PRODUCTS_DEFAULT_CONNECTIVE
                ),
                'filter_option_open_on_load' => $this->Render_Attributes->attr(
                    $attrs,
                    'filter_option_open_on_load',
                    false
                ),
                'type' => $this->Render_Attributes->attr(
                    $attrs,
                    'type',
                    'storefront'
                ),
                'no_filter_group_found_text' => $this->Render_Attributes->attr(
                    $attrs,
                    'no_filter_group_found_text',
                    $defaults['n']['noResultsFound']
                ),
                'filter_by_label_text' => $this->Render_Attributes->attr(
                    $attrs,
                    'filter_by_label_text',
                    $defaults['l']['filterBy']
                ),
                'page_size_label_text' => $this->Render_Attributes->attr(
                    $attrs,
                    'page_size_label_text',
                    $defaults['l']['pageSize']
                ),
                'clear_filter_selections_text' => $this->Render_Attributes->attr(
                    $attrs,
                    'clear_filter_selections_text',
                    $defaults['l']['clearAll']
                ),
                'selections_available_for_sale_text' => $this->Render_Attributes->attr(
                    $attrs,
                    'selections_available_for_sale_text',
                    $defaults['l']['availSale']
                ),
                'sort_by_label_text' => $this->Render_Attributes->attr(
                    $attrs,
                    'sort_by_label_text',
                    $defaults['l']['sort']
                ),
                'load_more_collections_busy_text' => $this->Render_Attributes->attr(
                    $attrs,
                    'load_more_collections_busy_text',
                    $defaults['l']['loading']
                ),
                'load_more_collections_text' => $this->Render_Attributes->attr(
                    $attrs,
                    'load_more_collections_text',
                    $defaults['l']['seeMore']
                ),
                'collections_heading' => $this->Render_Attributes->attr(
                    $attrs,
                    'collections_heading',
                    $defaults['l']['collections']
                ),
                'price_heading' => $this->Render_Attributes->attr(
                    $attrs,
                    'price_heading',
                    $defaults['l']['price']
                ),
                'tags_heading' => $this->Render_Attributes->attr(
                    $attrs,
                    'tags_heading',
                    $defaults['l']['tags']
                ),
                'types_heading' => $this->Render_Attributes->attr(
                    $attrs,
                    'types_heading',
                    $defaults['l']['types']
                ),
                'vendors_heading' => $this->Render_Attributes->attr(
                    $attrs,
                    'vendors_heading',
                    $defaults['l']['vendors']
                ),
                'show_search' => $this->Render_Attributes->attr(
                    $attrs,
                    'show_search',
                    false
                )
            ]
        ));

        return apply_filters('shopwp_storefront_default_settings', $settings);
    }
}
