<?php

namespace ShopWP;

use ShopWP\Factories;

require_once plugin_dir_path(__FILE__) . 'vendor/autoload.php';

Factories\Config_Factory::build()->init();

$Processing_Database = Factories\Processing\Database_Factory::build();
$Filesystem = Factories\Filesystem\Filesystem_Factory::build();

// If uninstall not called from WordPress, then exit.
if (!defined('WP_UNINSTALL_PLUGIN')) {
    exit();
}

if (!current_user_can('activate_plugins')) {
    exit();
}

$timestamp1 = wp_next_scheduled( 'shopwp_bulk_recheck_cron_hook' );
$timestamp2 = wp_next_scheduled( 'shopwp_auto_sync_cron_callback' );

$unschedule_result1 =  \wp_unschedule_event( $timestamp1, 'shopwp_bulk_recheck_cron_hook' );
$unschedule_result2 =  \wp_unschedule_event( $timestamp2, 'shopwp_auto_sync_cron_callback' );

\wp_clear_scheduled_hook('shopwp_bulk_recheck_cron_hook');
\wp_clear_scheduled_hook('shopwp_auto_sync_cron_callback');

if (is_multisite()) {
    $Processing_Database->uninstall_plugin_multisite();
} else {
    $Processing_Database->uninstall_plugin();
}

$Filesystem_Obj  = $Filesystem->bootstrap_filesystem();
$uploads_dir     = \wp_get_upload_dir();
$log_file        = $uploads_dir['basedir'] . '/shopwp.log';

$Filesystem_Obj->delete_file($log_file);